#include "manager.h"

Condominio* readCondomini(char* fileName, int *dim)
{
	int  i=0;
	Condominio temp, *array;
	FILE *f;

	if ((f=fopen(fileName, "r"))==NULL)
		{
			printf("errore in apertura file %s", fileName);
			exit(-1);
		}
		
	while (fscanf(f,"%d %d %s %d", &temp.codice, &temp.CAP, temp.via, &temp.civico)>0)
		(*dim)++;
		
	rewind(f);
	array= (Condominio *) malloc(sizeof(Condominio)* (*dim));
	
	while (fscanf(f,"%d %d %s %d", &temp.codice, &temp.CAP, temp.via, &temp.civico)>0)
		array[i++] = temp;
		
	fclose(f);
	
	return array;
}

ComA* readComA(char* fileName, int *dim){
	int i=0;
	char id;
	ComA  temp, *array;
char trash[100];
	FILE *f;

	if ((f=fopen(fileName, "r"))==NULL)
		{
			printf("errore apertura file %s", fileName);
			exit(-1);
		}
	while(fscanf(f,"%c",&id)>0)
		{
		if(id=='A')
			(*dim)++;
		fgets(trash,100,f);
		}
	rewind(f);
	
	array =(ComA *) malloc(sizeof(ComA)* (*dim));
	
	while(fscanf(f,"%c",&id)>0)
		{
		if (id=='A')
		{			
			fscanf(f,"%d",&temp.codice);
			fgets(temp.comunicazione,100,f);
			array[i++]=temp;
		}
		else
			fgets(trash,100,f);
		}
	
	fclose(f);
	
	return array;
}

ComE* readComE(char* fileName, int *dim){
	
		int i=0;
	char id;
	ComE  temp, *array;
char trash[100];
	FILE *f;

	if ((f=fopen(fileName, "r"))==NULL)
		{
			printf("errore  apertura file %s", fileName);
			exit(-1);
		}
	while(fscanf(f,"%c",&id)>0)
		{
		if(id=='E')
			(*dim)++;
		fgets(trash,100,f);
		}
	rewind(f);
	
	array =(ComE *) malloc(sizeof(ComE)* (*dim));
	
	while(fscanf(f,"%c",&id)>0)
		{
		if (id=='E')
		{			
			fscanf(f,"%d %d %s %d %d %d", &temp.codice, &temp.importo, temp.comunicazione, &temp.anno, &temp.mese, &temp.giorno);
			array[i++]=temp;
		}
		else
			fgets(trash,100,f);
		}
	
	fclose(f);
	
	return array;
}

int valuta(ComE a, ComE b)
{
	if (a.anno>b.anno)
		return 1;
	else
		if (a.anno<b.anno)
			return 0;
	
	if (a.mese>b.mese)
		return 1;
	else
		if (a.mese<b.mese)
			return 0;
			
	if (a.giorno<b.giorno)
		return 0;
			
	return 1;
}

void bubbleSort(ComE *e, int dimE){

int n = dimE;
int i; int ordinato = 0;
while (n>1 && ordinato==0){
	ordinato = 1;
	for (i=0; i<n-1; i++)
		if (valuta(e[i], e[i+1])) {
			ComE temp = e[i];
			e[i]= e[i+1];
			e[i+1] = temp;
			//scambia

			ordinato = 0; }
	n--; 
	}
}

ComE* stampaCondominio(Condominio *c, int dimC, ComA *a, int dimA, ComE *e, int dimE){
	
	int i=0;
	int indice=-1;
	ComE *ordinato;
	int codCond=-1;
	ordinato =(ComE *) malloc(sizeof(ComE)* dimE);
	
	//copio ComE
	for (i=0;i<dimE;i++)
		ordinato[i]=e[i];
		
	//ordino
	bubbleSort(ordinato, dimE);
	
	printf("Inserire un codice condominio");
	scanf("%d",&codCond);
	
	if(codCond==-1)
		{
		printf("errore in lettura");
		exit(1);
		}
	
	
	for (i=0;i<dimC;i++)
		if(c[i].codice == codCond)
			indice = i;
			
	if(indice==-1)
		{
		printf("errore Condominio non presente");
		exit(1);
		}
		
	printf("Comunicazioni in riferimento al condominio:\n");
	printf("Codice: %d CAP: %d Indirizzo: %s %d\n\n",c[indice].codice, c[indice].CAP, c[indice].via, c[indice].civico);
			
	for (i=0;i<dimE;i++)
		if(ordinato[i].codice == codCond)
		printf("- Importo: %d Comunicazione: %s Data: %d-%d-%d\n",ordinato[i].importo,ordinato[i].comunicazione,ordinato[i].anno,ordinato[i].mese,ordinato[i].giorno);
	
	
	return ordinato;
}